import { world } from 'mojang-minecraft';
import { ActionFormData, MessageFormData } from 'mojang-minecraft-ui';

world.events.tick.subscribe(() => {
	for (const player of world.getPlayers()) {
		let slot = player.selectedSlot;
		let health = Math.round(player.getComponent('health').current);
		player.runCommand(`scoreboard players set @s hotbar ${slot}`);
		player.runCommand(`scoreboard players set @s health ${health}`);
	}
});

world.events.beforeChat.subscribe(eventData => {
	const player = eventData.sender;
	switch (eventData.message) {
		case 'The chainsaw man is not real':
			player.runCommand('function chainsaw_rights_revoked');
			break;
		case 'The chainsaw man is fake':
			player.runCommand('function chainsaw_rights_revoked');
			break;
		case 'Devil Felled':
			player.runCommand('function chainsaw_rights_revoked');
			break;
		case 'No more rip and tear':
			player.runCommand('function chainsaw_rights_revoked');
			break;
		case 'Female Momotaro is not a thing':
			player.runCommand('function chainsaw_rights_revoked');
			break;
		case 'It is time to rest, Pochita':
			player.runCommand('function chainsaw_rights_revoked');
			break;
		case '!default':
			eventData.cancel = true;
			player.runCommand('function chainsaw_rights_revoked');
			break;
		default: break;
	}
});

let contractChooser = new ActionFormData();
contractChooser.title("Contract Chooser");
contractChooser.body("Welcome to the Public Safety! Here, we hunt devils using the power of other devils! To start, choose the devil you want to make a contract with.");
contractChooser.button("Curse");

let curseDevil = new MessageFormData();
curseDevil.title("Curse Devil");
curseDevil.body("The curse devil uses your life force to deal tremendous damage to the opponent after three precise hits.\n\nAre you sure you want to contract with the Curse Devil?");
curseDevil.button1("Yes");
curseDevil.button2("No");

world.events.beforeItemUse.subscribe(event => {
	if (event.item.id === "csm:contractor") {
		let player = event.source;
		contractor(player);
	};
});

const contractor = (player) => {
	contractChooser.show(player).then(r => {
		if(r.isCanceled) return;
		if(r.selection === 0) curseChoose(player);
	});
};

const curseChoose = (player) => {
	curseDevil.show(player).then(r => {
		if(r.selection === 0){
			contractor(player);
			return;
		};
		if(r.selection === 1){
			player.runCommand("function contract/clear");
			player.runCommand("function contract/curse");
		}
	});
};